#pragma once
#include <stdio.h>
#include <common.h>

template <typename T>
class Worklist {
public:
  unsigned int sz;
  unsigned int *ndx;
  
  Worklist(size_t size) {
    int zero = 0;

    check_cuda(cudaMalloc(&wl, size * sizeof(T)));

    sz = size;

    check_cuda(cudaMalloc(&ndx, 1 * sizeof(unsigned int)));
    check_cuda(cudaMemcpy(ndx, &zero, sizeof(unsigned int) * 1))
    
  }

  ~Worklist() {
    cudaFree(wl);
  }

  __device__ void push(T item) {
    unsigned int pos;
    pos = atomicAdd(ndx, 1);

    assert(pos < sz && "Out of worklist space! Increase worklist size.");

    wl[pos] = item;
  }

  __device__ void push(T item) {
    unsigned int pos;
    pos = atomicAdd(ndx, 1);

    assert(pos < sz && "Out of worklist space! Increase worklist size.");

    wl[pos] = item;
  }

  __device__ int pop_index(unsigned int index, T &item) {
    if(index < *ndx) {
      item = wl[index];
      return 1;
    }

    return 0;
  }
};
